
#include <jni.h>
#include "ocr_manager_JavaChecker.h" //the java side header file

#include <afx.h>
#include <deque>
#include <aspell.h>
#include <direct.h>

using namespace std;

typedef deque<int> INTDEQUE;

char gDictDir[500],gDataDir[500],gDictionary[500];
AspellCanHaveError	*gReturn;
AspellSpeller	*gSpeller;
AspellConfig	*gConfig;

typedef deque<CString> SDQ;
typedef deque<int> IDQ;

int AddToPersonalList(AspellSpeller* speller,unsigned char* iword);
int CheckCombinedWord(AspellSpeller* speller,CString* wgroup,int wno,int center,CString* &comword,int &comwordno);
int CheckConfigError(AspellConfig* config);
int CheckDocumentNoCom(AspellSpeller* speller,char *file);
int CheckDocumentWithCom(AspellSpeller* speller,char *file,int range=1);
int CheckSingleWord(AspellSpeller* speller,unsigned char* iword,CString* &suggestion);
int CheckError(AspellSpeller* speller);
int	ExtractPureWord(unsigned char* iword,CString pureword[3]);
int LatinCharType(WCHAR ucode);
int IgnoreWord(AspellSpeller* speller,unsigned char* iword);
int RemoveDashInWord(CString &iword);
int SelectDictionary(AspellConfig* config,char* lang,char* region=NULL);
int SetDictDirectory(AspellConfig* config,char* dataDir,char* dictDir);

unsigned char *JNU_GetStringNativeChars(JNIEnv *env, jstring jstr);

JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_AddToPersonalList
	(JNIEnv *env, jclass jcls, jstring iword);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_CheckDocument
	(JNIEnv *env, jclass jcls, jstring dfile, jint range);
JNIEXPORT jobject JNICALL Java_ocr_manager_JavaChecker_CheckMultipleWord
	(JNIEnv *env, jclass jcls, jobjectArray warr, jint wno, jint mwid);
JNIEXPORT jobject JNICALL Java_ocr_manager_JavaChecker_CheckSingleWord
	(JNIEnv *env, jclass jcls, jstring iword);
JNIEXPORT jint JNICALL Java_ocr_manager_JavaChecker_CreateNewDictionary
  (JNIEnv *env, jclass jcls, jstring dict_dir, jstring data_dir, jobjectArray wlfiles, jint fno, jstring dict_name);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_IgnoreWord
	(JNIEnv *env, jclass jcls, jstring iword);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SaveIgnoreWordList
	(JNIEnv *env, jclass jcls, jstring listfile);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SavePersonalWordList
	(JNIEnv *env, jclass jcls, jstring listfile);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetDataDirectory
	(JNIEnv *env, jclass jcls, jstring data_dir);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetDictDirectory
	(JNIEnv *env, jclass jcls, jstring dict_dir);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_DictionarySetup
	(JNIEnv *env, jclass jcls, jstring dict);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetIgnoreWordList
	(JNIEnv *env, jclass jcls, jstring listfile);
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetPersonalWordList
	(JNIEnv *env, jclass jcls, jstring listfile);

/*
 * Class:     JavaChecker
 * Method:    AddToPersonalList
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_AddToPersonalList(JNIEnv *env, jclass jcls, jstring iword)
{
	jboolean iscopy;
	unsigned char* igWord=JNU_GetStringNativeChars(env,iword);
	aspell_speller_add_to_personal(gSpeller,(char*)igWord,-1);
	CheckError(gSpeller);
	if(igWord!=NULL){delete [] igWord; igWord=NULL;}
}
/*
 * Class:     JavaChecker
 * Method:    CheckDocument
 * Signature: (Ljava/lang/String;I)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_CheckDocument(JNIEnv *env, jclass jcls, jstring dfile, jint range)
{
	FILE *fp,*ft;
	unsigned char wptr[100];
	char rfile[300],file[300];
	CString wstr,sword[3];
	CString *corWord=NULL;
	CString *sug=NULL;
	int split_no,pop_no,twno,i,j,k,m,sug_no,center_id,corWordNo,qsize;
	CString *rword=NULL;
	CString *gword=NULL;
	CString *fword=NULL;
	SDQ smyq;
	IDQ imyq;
	SDQ::iterator spq;
	IDQ::iterator ipq;
	
	jboolean iscopy;
	const char *jfile=env->GetStringUTFChars(dfile,&iscopy);
	sprintf(file,"%s",jfile);
	env->ReleaseStringUTFChars(dfile,jfile);

	if(range<=0)
		CheckDocumentNoCom(gSpeller,file);

	sprintf(rfile,"%s.check",file);
	
	gword=new CString[2*range+1];
	if(gword==NULL){printf("Out of memory.\n"); return;}
	
	//get the total number of words
	fp=fopen(file,"rt");
	if(fp==NULL){
		printf("Can not open file %s to read word.\n",file);
		return;
	}
	
	twno=0;
	while(fscanf(fp,"%s",wptr)!=EOF) twno++;
	rewind(fp);

	rword=new CString[twno];
	if(rword==NULL){printf("Out of memory.\n"); return;}
	for(i=0;i<twno;i++){
		fscanf(fp,"%s",wptr);
		rword[i].Format("%s",wptr);
	}
	fclose(fp);

	ft=fopen(rfile,"wt");
	if(ft==NULL){
		printf("Can not open file %s to write.\n",rfile);
		return;
	}

	//printf("Begin checking.\n");
	
	for(k=0;k<twno;k++){
		//printf("Checking word %d\n",k);
		split_no=ExtractPureWord((unsigned char*)LPCTSTR(rword[k]),sword);
		//printf("%s \n",sword[1]);
		if(!sword[1].IsEmpty()){
			sug_no=CheckSingleWord(gSpeller,(unsigned char*)LPCTSTR(sword[1]),sug);
			printf("Suggest number %d\n",sug_no);
			if(sug_no==0 || sug_no==-1){//The word is correct or incorrect but no suggestions can be found
				qsize=imyq.size();
				if(qsize<(2*range+1)){//no safe word
					imyq.push_back(split_no);
					for(i=0;i<3;i++){
						if(!sword[i].IsEmpty())
							smyq.push_back(sword[i]);
					}
				}
				else{//the first word is safe
					ipq=imyq.begin();
					pop_no=*ipq;
					imyq.pop_front();
					for(i=0;i<pop_no;i++){
						spq=smyq.begin();
						wstr=*spq;
						fprintf(ft,"%s ",wstr);
						smyq.pop_front();
					}
					fprintf(ft,"\n");
					//push the current word into the queue
					imyq.push_back(split_no);
					for(i=0;i<3;i++){
						if(!sword[i].IsEmpty())
							smyq.push_back(sword[i]);
					}
				}	
			}
			else{//incorrect word with suggestions
				int id=0;
				for(i=-range;i<=range;i++){
					if((k+i)>=0 && (k+i)<twno){
						gword[id]=rword[k+i];
						if(i==0){center_id=id;}
						id++;
					}
				}
				m=CheckCombinedWord(gSpeller,gword,id,center_id,corWord,corWordNo);
				if(m>0){//found one perfect combination,skip the next neighbors (in range)
					k+=range;
					//first remove the safe string
					qsize=imyq.size();
					if(qsize>range){
						for(i=0;i<(qsize-range);i++){
							ipq=imyq.begin();
							pop_no=*ipq;
							imyq.pop_front();
							for(j=0;j<pop_no;j++){
								spq=smyq.begin();
								wstr=*spq;
								fprintf(ft,"%s ",wstr);
								smyq.pop_front();
							}
						}
					}
					//clear the deque
					imyq.clear();
					smyq.clear();
					//ouput the perfect combination
					for(i=0;i<corWordNo;i++)
						fprintf(ft,"%s ",corWord[i]);
					fprintf(ft,"\n");
				}
				else{//no perfect combination, output the first suggestion to the deque
					if(imyq.size()<(2*range+1)){//no safe word
						imyq.push_back(split_no);
						for(i=0;i<3;i++){
							if(!sword[i].IsEmpty()){
								if(i==1){
									if(sug_no>0)
										//smyq.push_back(sug[0]);
										smyq.push_back(sword[i]);
									else
										smyq.push_back(sword[i]);
								}
								else
									smyq.push_back(sword[i]);
							}
						}
					}
					else{//the first word is safe
						ipq=imyq.begin();
						pop_no=*ipq;
						imyq.pop_front();
						for(i=0;i<pop_no;i++){
							spq=smyq.begin();
							wstr=*spq;
							fprintf(ft,"%s ",wstr);
							smyq.pop_front();
						}
						fprintf(ft,"\n");
						//push the current word into the queue
						imyq.push_back(split_no);
						for(i=0;i<3;i++){
							if(!sword[i].IsEmpty()){
								if(i==1){
									if(sug_no>0)
										//smyq.push_back(sug[0]);
										smyq.push_back(sword[i]);
									else
										smyq.push_back(sword[i]);
								}
								else
									smyq.push_back(sword[i]);
							}
						}
					}	
					delete [] corWord;
					corWord=NULL;
				}
				delete [] sug;
				sug=NULL;
			}
		}
		else{//the whole word does not contain even one regular character, don't check
			qsize=imyq.size();
			if(qsize<(2*range+1)){//no safe word
				imyq.push_back(split_no);
				for(i=0;i<3;i++){
					if(!sword[i].IsEmpty())
						smyq.push_back(sword[i]);
				}
			}
			else{//the first word is safe
				ipq=imyq.begin();
				pop_no=*ipq;
				imyq.pop_front();
				for(i=0;i<pop_no;i++){
					spq=smyq.begin();
					wstr=*spq;
					fprintf(ft,"%s ",wstr);
					smyq.pop_front();
				}
				fprintf(ft,"\n");
				//push the current word into the queue
				imyq.push_back(split_no);
				for(i=0;i<3;i++){
					if(!sword[i].IsEmpty())
						smyq.push_back(sword[i]);
				}
			}	
		}
	}
	if(!imyq.empty()){
		qsize=imyq.size();
		for(i=0;i<qsize;i++){
			ipq=imyq.begin();
			pop_no=*ipq;
			imyq.pop_front();
			for(j=0;j<pop_no;j++){
				spq=smyq.begin();
				wstr=*spq;
				fprintf(ft,"%s ",wstr);
				smyq.pop_front();
			}
		}
	}
	fclose(ft);
}
/*
 * Class:     JavaChecker
 * Method:    CheckMultipleWord
 * Signature: (Ljava/lang/String;II)LMultiWordList;
 */
JNIEXPORT jobject JNICALL Java_ocr_manager_JavaChecker_CheckMultipleWord(JNIEnv *env, jclass jcls, jobjectArray warr, jint wno, jint mwid)
{
	CString wstr,sword[3];
	CString *corWord=NULL;
	CString *sug=NULL;
	int split_no,id,i,j,m,sug_no,center_id,corWordNo;
	CString *rword=NULL;
	CString *gword=NULL;
	bool ReturnAtOnce;

	rword=new CString[wno];
	if(rword==NULL){printf("Out of memory.\n"); return 0;}

	//convert the jstring into C++ strings
	jstring str;
	jboolean iscopy;
	unsigned char* tstr;

	for(i=0;i<wno;i++){
		str=(jstring)env->GetObjectArrayElement(warr,i);
		tstr=JNU_GetStringNativeChars(env,str);
		rword[i].Format("%s",tstr);
		if(tstr!=NULL){delete [] tstr; tstr=NULL;}
	}
	
	jobjectArray ret,row;
  jclass cls;
	jobject obj;
  jmethodID mid;
	int ckresult;
  
	//obtain the class and method id in java
  cls=env->FindClass("Locr/manager/MultiWordList;");
	if(cls==0){printf("Can not find the MultiWordList class.\n"); return 0;}
	obj=env->AllocObject(cls);
	mid=env->GetMethodID(cls, "SetList","([[Ljava/lang/String;II)V");
  if(mid==0) {
    printf("Can't find method SetList\n");
    return 0;
  }
	
	//check the word
	ReturnAtOnce=false;
	split_no=ExtractPureWord((unsigned char*)LPCTSTR(rword[mwid]),sword);
	if(sword[1].IsEmpty()){//no pure latin word exists
		ReturnAtOnce=true;
	}
	else{
		sug_no=CheckSingleWord(gSpeller,(unsigned char*)LPCTSTR(sword[1]),sug);
		if(sug_no==-1)//correct word 
			ReturnAtOnce=true;
		else if(sug_no==0)//incorrect word but no suggestion given
			ReturnAtOnce=false;
		else//incorrect word with suggestions
			ReturnAtOnce=false;
	}
	if(ReturnAtOnce){//no need to check any more, return the resutl here
		if(split_no==1){
			if(sword[1].IsEmpty())//main word does not contain regular character (most likely is punctuation)
				ckresult=-1;
			else ckresult=0;
		}
		else if(split_no==3) ckresult=3;
		else{//split_no==2
			if(!sword[0].IsEmpty()) ckresult=1;
			else ckresult=2;
		}
		//Create array to send back
		row=(jobjectArray)env->NewObjectArray(wno+split_no-1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
		ret=(jobjectArray)env->NewObjectArray(1,env->GetObjectClass(row),0); //only one line of strings
		id=0;
		for(i=0;i<mwid;i++){
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(rword[i])));
			id++;
		}
		for(i=0;i<3;i++){
			if(!sword[i].IsEmpty()){
				env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sword[i])));
				id++;
			}
		}
		for(i=mwid+1;i<wno;i++){
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(rword[i])));
			id++;
		}
		env->SetObjectArrayElement(ret,0,row);
		env->ExceptionClear();
		env->CallVoidMethod(obj,mid,ret,1,ckresult);
		if(env->ExceptionOccurred()){
			printf("Error occured copying array back\n");
			env->ExceptionDescribe();
			env->ExceptionClear();
		}
		//free memory
		if(rword!=NULL){delete [] rword; rword=NULL;}
		env->DeleteLocalRef(ret);
		return obj;
	}
	//if the code can perform till here, which means the middle word is incorrect, so we need to check if we
	//can combine it with the previous and following word to create a correct word
	gword=new CString[wno];
	if(gword==NULL){printf("Out of memory.\n"); return 0;}
	for(i=0;i<wno;i++)
		gword[i]=rword[i];
	center_id=mwid;
	//check all combination of words. Note, here we are not using the split resutl of the main word
	m=CheckCombinedWord(gSpeller,gword,wno,center_id,corWord,corWordNo);
	ckresult=4;
	//printf("The return m value is %d \n",m);
	if(m>0){//found one perfect combination,skip the next neighbors (in range)
		//Create array to send back
		row=(jobjectArray)env->NewObjectArray(corWordNo,env->FindClass("java/lang/String"),env->NewStringUTF(""));
		ret=(jobjectArray)env->NewObjectArray(1,env->GetObjectClass(row),0); //only one line of strings
		for(i=0;i<corWordNo;i++){
			env->SetObjectArrayElement(row,i,env->NewStringUTF((char *)LPCTSTR(corWord[i])));
		}
		env->SetObjectArrayElement(ret,0,row);
		env->ExceptionClear();
		env->CallVoidMethod(obj,mid,ret,1,ckresult);
		if(env->ExceptionOccurred()){
			printf("Error occured copying array back\n");
			env->ExceptionDescribe();
			env->ExceptionClear();
		}
		if(rword!=NULL){delete [] rword; rword=NULL;}
		if(corWord!=NULL){delete [] corWord; corWord=NULL;}
		if(gword!=NULL){delete [] gword; gword=NULL;}
		env->DeleteLocalRef(ret);
		return obj;
	}
	//if the code can perform till here, which means the middle word is incorrect, and no perfect combination
	//was found by combing the word with its adjacencies, but we always assume the previous word has already been
	//corrected, the output will be the words before the main word, suggestions of main word, and the words after
	//the main word; But be carefule because the main word may have already been split and non-regular characters
	//were extracted
	ckresult=5;
	if(sug_no>0){//no perfect combination found, main word has suggestions
		row=(jobjectArray)env->NewObjectArray(wno+split_no-1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
		ret=(jobjectArray)env->NewObjectArray(sug_no,env->GetObjectClass(row),0); //sug_no lines of strings
		//printf("Suggestion number is: %d\n",sug_no);
		if(split_no==1)//sword[1] can not be empty because that's the return at one case, can not reach here
			ckresult=5;
		else if(split_no==3)
			ckresult=8;
		else{//split_no==2
			if(!sword[0].IsEmpty()) ckresult=7;
			else ckresult=6;
		}
		for(i=0;i<sug_no;i++){
			row=(jobjectArray)env->NewObjectArray(wno+split_no-1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
			id=0;
			for(j=0;j<mwid;j++){
				env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(rword[j])));
				id++;
			}
			if(!sword[0].IsEmpty()){
				env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sword[0])));
				id++;
			}
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sug[i])));
			id++;
			if(!sword[2].IsEmpty()){
				env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sword[2])));
				id++;
			}
			for(j=mwid+1;j<wno;j++){
				env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(rword[j])));
				id++;
			}
			//printf("Index is %d\n",id);
			env->SetObjectArrayElement(ret,i,row);
			env->DeleteLocalRef(row);
		}
		env->ExceptionClear();
		env->CallVoidMethod(obj,mid,ret,sug_no,ckresult);
		if(env->ExceptionOccurred()){
			printf("Error occured copying array back\n");
			env->ExceptionDescribe();
			env->ExceptionClear();
		}
		if(rword!=NULL){delete [] rword; rword=NULL;}
		if(sug!=NULL){delete [] sug; sug=NULL;}
		if(gword!=NULL){delete [] gword; gword=NULL;}
		env->DeleteLocalRef(ret);
		return obj;
	}
	//if the code can perform till here, which means the middle word is incorrect, no perfect combination
	//was found by combing the word with its adjacencies, and we even can not find any suggestion for the 
	//incorrect main word, so the return will be just as the input (in this case, the only way to correct this
	//word is ask the user to correct it) 
	ckresult=9;
	row=(jobjectArray)env->NewObjectArray(wno+split_no-1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
	ret=(jobjectArray)env->NewObjectArray(1,env->GetObjectClass(row),0); //sug_no lines of strings
	if(split_no==1){
		ckresult=9;
	}
	else if(split_no==3) ckresult=12;
	else{//split_no==2
		if(!sword[0].IsEmpty()) ckresult=11;
		else ckresult=10;
	}
	for(i=0;i<1;i++){
		row=(jobjectArray)env->NewObjectArray(wno+split_no-1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
		id=0;
		for(j=0;j<mwid;j++){
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(rword[j])));
			id++;
		}
		if(!sword[0].IsEmpty()){
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sword[0])));
			id++;
		}
		env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sword[1])));
		id++;
		if(!sword[2].IsEmpty()){
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(sword[2])));
			id++;
		}
		for(j=mwid+1;j<wno;j++){
			env->SetObjectArrayElement(row,id,env->NewStringUTF((char *)LPCTSTR(rword[j])));
			id++;
		}
		//printf("Index is %d\n",id);
		env->SetObjectArrayElement(ret,i,row);
		env->DeleteLocalRef(row);
	}
	env->ExceptionClear();
	env->CallVoidMethod(obj,mid,ret,1,ckresult);
	if(env->ExceptionOccurred()){
		printf("Error occured copying array back\n");
		env->ExceptionDescribe();
		env->ExceptionClear();
	}
	if(rword!=NULL){delete [] rword; rword=NULL;}
	//if(sug!=NULL){delete [] sug; sug=NULL;}
	if(gword!=NULL){delete [] gword; gword=NULL;}
	env->DeleteLocalRef(ret);
	return obj;
}
/*
 * Class:     JavaChecker
 * Method:    CheckSingleWord
 * Signature: (Ljava/lang/String;)LWordList;
 */
JNIEXPORT jobject JNICALL Java_ocr_manager_JavaChecker_CheckSingleWord(JNIEnv *env, jclass jcls, jstring iword)
{
	int correct,sno,i;
	const AspellWordList *wl=NULL;
	AspellStringEnumeration *els;
	const char *sug;
	CString AllSuggestions[500];
	jboolean iscopy;
	CString CheckWord,sword[3];
	int split_no;
	bool PureSymbol;

	unsigned char *jiword=JNU_GetStringNativeChars(env,iword);
	CheckWord.Format("%s",jiword);
	if(jiword!=NULL){delete [] jiword; jiword=NULL;}

	split_no=ExtractPureWord((unsigned char*)LPCTSTR(CheckWord),sword);

	if(sword[1].IsEmpty()){//the single word is a punctuation or symbol, not Latin word
		PureSymbol=true;
	}
	else{
		PureSymbol=false;
		correct=aspell_speller_check(gSpeller,(char *)LPCTSTR(sword[1]),-1);
		//correct==1 means correct word
		if(correct!=1){
			wl=aspell_speller_suggest(gSpeller,CheckWord,-1);
			els=aspell_word_list_elements(wl);
			sno=0;
			while((sug=aspell_string_enumeration_next(els))!=0){
				AllSuggestions[sno].Format("%s",sug);
				sno++;
			}
			//sno<=0 means no suggestions
		}
	}

	//return the suggestion to the Java class
	jclass cls;
	cls=env->FindClass("Locr/manager/WordList;");
	// If this class does not exist then return null.
	if(cls==0) {printf("Can not find the class WordList\n"); return 0;}
	jmethodID idSetWord,idSetPreString,idSetPosString;
	
	idSetWord=env->GetMethodID(cls,"SetWord","([Ljava/lang/String;I)V");
	if(idSetWord==0){
		printf("Can not find the method ID of SetWord.\n");
		return 0;
	}
	idSetPreString=env->GetMethodID(cls,"SetPreString","(Ljava/lang/String;)V");
	if(idSetPreString==0){
		printf("Can not find the method ID of SetPreString.\n");
		return 0;
	}
	idSetPosString=env->GetMethodID(cls,"SetPosString","(Ljava/lang/String;)V");
	if(idSetPosString==0){
		printf("Can not find the method ID of SetPosString.\n");
		return 0;
	}

	// Allocate memory for a new WrodList class object.  
	jobject obj=env->AllocObject(cls);
	jobjectArray sugArr;
	
	int WordNumber;
	jstring prestr,posstr;
	if(!PureSymbol){
		//set the pre and pos string
		if(!sword[0].IsEmpty()){
			prestr=env->NewStringUTF((char *)LPCTSTR(sword[0]));
			env->ExceptionClear();
			env->CallVoidMethod(obj, idSetPreString, prestr);
			if(env->ExceptionOccurred()) {
				printf("Error occured when setting PreString.\n");
				env->ExceptionDescribe();
				env->ExceptionClear();
			}
		}
		if(!sword[2].IsEmpty()){
			posstr=env->NewStringUTF((char *)LPCTSTR(sword[2]));
			env->ExceptionClear();
			env->CallVoidMethod(obj, idSetPosString, posstr);
			if(env->ExceptionOccurred()) {
				printf("Error occured when setting PosString.\n");
				env->ExceptionDescribe();
				env->ExceptionClear();
			}
		}
		if(correct!=1){
			if(sno>0){ //incorrect word with suggestions
				WordNumber=sno;
				sugArr=(jobjectArray)env->NewObjectArray(sno,env->FindClass("java/lang/String"),env->NewStringUTF(""));
				for(i=0;i<sno;i++)
					env->SetObjectArrayElement(sugArr,i,env->NewStringUTF((char*)LPCTSTR(AllSuggestions[i])));
			}
			else{//incorrect with no suggestions
				WordNumber=0;
				sugArr=(jobjectArray)env->NewObjectArray(1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
				env->SetObjectArrayElement(sugArr,0,env->NewStringUTF((char*)LPCTSTR(sword[1])));
			}
		}
		else{
			WordNumber=-1;
			sugArr=(jobjectArray)env->NewObjectArray(1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
			env->SetObjectArrayElement(sugArr,0,env->NewStringUTF((char*)LPCTSTR(sword[1])));
		}
	}
	else{//pure symbol
		WordNumber=-1;
		sugArr=(jobjectArray)env->NewObjectArray(1,env->FindClass("java/lang/String"),env->NewStringUTF(""));
		env->SetObjectArrayElement(sugArr,0,env->NewStringUTF((char*)LPCTSTR(sword[0])));
	}
	env->ExceptionClear();
  env->CallVoidMethod(obj, idSetWord, sugArr,WordNumber);
  if(env->ExceptionOccurred()) {
    printf("Error occured when copying array back.\n");
    env->ExceptionDescribe();
    env->ExceptionClear();
  }
	//free the local suggestion array
	env->DeleteLocalRef(sugArr);
	return obj;
}

/*
 * Class:     ocr_manager_JavaChecker
 * Method:    CreateNewDictionary
 * Signature: (Ljava/lang/String;Ljava/lang/String;[Ljava/lang/String;ILjava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_ocr_manager_JavaChecker_CreateNewDictionary
  (JNIEnv *env, jclass jcls, jstring dict_dir, jstring data_dir, jobjectArray wlfiles, jint fno, jstring dict_name)
{
	CString* wListFiles=NULL;
	int i;
	jstring str;
	jboolean iscopy;
	const char *tstr,*dictDir,*dataDir,*dictName;
	
	//Get the "dict" and "data" directory and the name of the new dictionary
	dictDir=env->GetStringUTFChars(dict_dir,&iscopy);
	dataDir=env->GetStringUTFChars(data_dir,&iscopy);
	dictName=env->GetStringUTFChars(dict_name,&iscopy);

	CString TempString;

	//determine if the input dictionary name is an effective name
	TempString.Format("%s",dictName);
	if(TempString.GetLength()!=2){
		printf("The specified dictionary name must only have two characters.\n");
		return -1;
	}

	if(fno<1){
		printf("You must specify at least one word list file.\n");
		return -1;
	}
	//Get all the word list files
	wListFiles=new CString[fno];
	if(wListFiles==NULL){printf("Out of memory.\n"); return -1;}
	//convert the jstring into C++ strings
	for(i=0;i<fno;i++){
		str=(jstring)env->GetObjectArrayElement(wlfiles,i);
		tstr=env->GetStringUTFChars(str,&iscopy);
		wListFiles[i].Format("%s",tstr);
		env->ReleaseStringUTFChars(str,tstr);
	}

	//aspell --data-dir=C:\users\hfma\aspell\data --lang=cb create master ./en_TT.rws < CebuanoWordList.txt
	
	//put the content of all the word list file into a single text file
	char temp_file[500];
	char wptr[100];
	FILE *fp,*fs;
	sprintf(temp_file,"%s\\tempdata.txt",dictDir);
	fp=fopen(temp_file,"wt");
	if(fp==NULL){printf("Can not open the temporary data file to write.\n"); return -1;}
	for(i=0;i<fno;i++){
		fs=fopen(wListFiles[i],"rt");
		if(fs==NULL){printf("Can not open the word list file %s to read.\n",wListFiles[i]); fclose(fp); return -1;}
		while(fscanf(fs,"%s",wptr)!=EOF) fprintf(fp,"%s\n",wptr);
		fclose(fs);
	}
	fclose(fp);
	if(wListFiles!=NULL){
		delete [] wListFiles;
		wListFiles=NULL;
	}

	char* currentDir=new char[200];
	_getcwd(currentDir,200);
	if(_chdir(dictDir)!=-1){
		char command[500];
		sprintf(command,"aspell --data-dir=%s --lang=cb create master ./en_%s.rws < %s",dataDir,dictName,temp_file);
		//printf("%s\n",command);
		//compile the dictionary
		system(command);
		//delete the temporary file
		sprintf(command,"del %s",temp_file);
		system(command);
		//change back to the original directory
		_chdir(currentDir);
		if(currentDir!=NULL){
			delete [] currentDir;
			currentDir=NULL;
		}
		return 1;
	}
	else{
		printf("The specified dict directory %s doesn't exist!\n",dictDir);
		return -1;
	}
}
/*
 * Class:     JavaChecker
 * Method:    IgnoreWord
 * Signature: (Ljava/lang/String;)V
 */
//modified by H.Ma at 02.23.2004 to asuure the correct conversion of characters with accent (important)
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_IgnoreWord(JNIEnv *env, jclass jcls, jstring iword)
{
	unsigned char* igword=NULL;
	
	igword=JNU_GetStringNativeChars(env,iword);
	//printf("The converted word is %s ",igword);
	aspell_speller_add_to_session(gSpeller,(char*)igword,-1);
	CheckError(gSpeller);
	if(igword!=NULL){
		delete [] igword;
		igword=NULL;
	}
}

/*
 * Class:     JavaChecker
 * Method:    SaveIgnoreWordList
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SaveIgnoreWordList(JNIEnv *env, jclass jcls, jstring listfile)
{
	FILE *fp;
	const char *lfile;
	jboolean iscopy;

	lfile=env->GetStringUTFChars(listfile,&iscopy);
	fp=fopen(lfile,"wt");
	if(fp==NULL){printf("Can not open the ignore word list file %s to write.\n",lfile); return;}
	env->ReleaseStringUTFChars(listfile,lfile);

	const AspellWordList *wl;
	wl=aspell_speller_session_word_list(gSpeller);
	if(wl==0){
		printf("Error: %s\n", aspell_speller_error_message(gSpeller));
		fclose(fp);
		return;
	}
	AspellStringEnumeration *els=aspell_word_list_elements(wl);
	const char * igWord;
	while((igWord=aspell_string_enumeration_next(els))!=0){
		fprintf(fp,"%s\n",igWord);
	}
	fclose(fp);
}

/*
 * Class:     JavaChecker
 * Method:    SavePersonalWordList
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SavePersonalWordList(JNIEnv *env, jclass jcls, jstring listfile)
{
	FILE *fp;
	const char *lfile;
	jboolean iscopy;

	lfile=env->GetStringUTFChars(listfile,&iscopy);
	fp=fopen(lfile,"wt");
	if(fp==NULL){printf("Can not open the ignore word list file %s to write.\n",lfile); return;}
	env->ReleaseStringUTFChars(listfile,lfile);

	const AspellWordList *wl;
	wl=aspell_speller_personal_word_list(gSpeller);
	if(wl==0){
		printf("Error: %s\n", aspell_speller_error_message(gSpeller));
		fclose(fp);
		return;
	}
	AspellStringEnumeration *els=aspell_word_list_elements(wl);
	const char * addWord;
	while((addWord=aspell_string_enumeration_next(els))!=0){
		fprintf(fp,"%s\n",addWord);
	}
	fclose(fp);
}
/*
 * Class:     JavaChecker
 * Method:    SetDataDirectory
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetDataDirectory(JNIEnv *env, jclass jcls, jstring data_dir)
{
	jboolean iscopy;

	const char *DataDir=env->GetStringUTFChars(data_dir,&iscopy);
	sprintf(gDataDir,"%s",DataDir);
	env->ReleaseStringUTFChars(data_dir,DataDir);
}

/*
 * Class:     JavaChecker
 * Method:    SetDictDirectory
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetDictDirectory(JNIEnv *env, jclass jcls, jstring dict_dir)
{
	jboolean iscopy;

	const char* DictDir=env->GetStringUTFChars(dict_dir,&iscopy);
	sprintf(gDictDir,"%s",DictDir);
	//printf("Dict dir is %s\n",gDictDir);
	env->ReleaseStringUTFChars(dict_dir,DictDir);
}

/*
 * Class:     JavaChecker
 * Method:    DictionarySetup
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_DictionarySetup(JNIEnv *env, jclass jcls, jstring dict)
{
	jboolean iscopy;

	const char *Dict=env->GetStringUTFChars(dict,&iscopy);
	sprintf(gDictionary,"%s",Dict);
	env->ReleaseStringUTFChars(dict,Dict);

	gConfig=new_aspell_config();

	SetDictDirectory(gConfig,gDataDir,gDictDir);
	SelectDictionary(gConfig,gDictionary);
	
	gReturn=new_aspell_speller(gConfig);

  delete_aspell_config(gConfig);
  if(aspell_error(gReturn)!=0){
    printf("Error: %s\n",aspell_error_message(gReturn));
    delete_aspell_can_have_error(gReturn);
    return;
  }
  gSpeller=to_aspell_speller(gReturn);
  gConfig=aspell_speller_config(gSpeller);
}

/*
 * Class:     JavaChecker
 * Method:    SetIgnoreWordList
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetIgnoreWordList(JNIEnv *env, jclass jcls, jstring listfile)
{
	FILE *fp;
	const char *lfile;
	jboolean iscopy;
	char igWord[50];

	lfile=env->GetStringUTFChars(listfile,&iscopy);
	fp=fopen(lfile,"rt");
	if(fp==NULL){printf("Can not open the ignore word list file %s to read.\n",lfile); return;}
	env->ReleaseStringUTFChars(listfile,lfile);
	while(fscanf(fp,"%s",igWord)!=EOF){
		aspell_speller_add_to_session(gSpeller,igWord,-1);
		CheckError(gSpeller);
	}
	fclose(fp);
}
/*
 * Class:     JavaChecker
 * Method:    SetPersonalWordList
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_ocr_manager_JavaChecker_SetPersonalWordList(JNIEnv *env, jclass jcls, jstring listfile)
{
	FILE *fp;
	const char *lfile;
	jboolean iscopy;
	char addWord[50];

	lfile=env->GetStringUTFChars(listfile,&iscopy);
	fp=fopen(lfile,"rt");
	if(fp==NULL){printf("Can not open the personal word list file %s to read.\n",lfile); return;}
	env->ReleaseStringUTFChars(listfile,lfile);
	while(fscanf(fp,"%s",addWord)!=EOF){
		aspell_speller_add_to_session(gSpeller,addWord,-1);
		aspell_speller_add_to_personal(gSpeller,addWord,-1);
		CheckError(gSpeller);
	}
	fclose(fp);
}

/************************************************************************************************************
	the following are the functions needed by the JNI native methods, which are not normal C++ functions while
	use many characteristics of java
*************************************************************************************************************/
//JNU_GetStringNativeChars() convert the input jstring (java string) into the string that can be accepted by
//C++ fucntion. The reason that we don't use fucntion "GetStringUTFChars()" is because that function may 
//gave incorrect conversion when the original string contains characters with accent
//Input:
//	env:		the java jni environment 
//	jstr:		the input jstring want to convert
//Return:
//	the converted string
//	if NULL, something was wrong
//Created by H.Ma at 02.23.2004
unsigned char *JNU_GetStringNativeChars(JNIEnv *env, jstring jstr)
{
	//const char* cigword;
	unsigned char *igword=new unsigned char[100];
	//jboolean iscopy;

	//cigword=env->GetStringUTFChars(jstr,&iscopy);
	//sprintf(igword,"%s",cigword);
	//env->ReleaseStringUTFChars(jstr,cigword);
	jbyteArray bytes = 0;
	jthrowable exc;
	jclass scls;
	jobject sobj;
	jmethodID MID_String_getBytes,constructorID; 
	jint len;

	if (env->EnsureLocalCapacity(2) < 0) {
		return 0; // out of memory error 
	}

	scls=env->FindClass("Ljava/lang/String;");
	if(scls==0){
		printf("Can not find the class String.\n");
		return 0;
	}

	constructorID=env->GetMethodID(scls,"<init>","(Ljava/lang/String;)V");
	if(constructorID==0){
		printf("Can not find the constructor method ID of String.\n");
		return 0;
	}

	MID_String_getBytes=env->GetMethodID(scls,"getBytes","()[B");
	if(MID_String_getBytes==0){
		printf("Can not find the method ID of getBytes.\n");
		return 0;
	}
	
	sobj=env->NewObject(scls,constructorID,jstr);
	bytes=(jbyteArray)env->CallObjectMethod(sobj,MID_String_getBytes);
	exc = env->ExceptionOccurred();
	if (!exc) {
		len = env->GetArrayLength(bytes);
		igword=new unsigned char[len+1];
		if(igword == 0) {
		//JNU_ThrowByName(env, "java/lang/OutOfMemoryError",0);
			env->DeleteLocalRef(bytes);
			return 0;
		}
		env->GetByteArrayRegion(bytes, 0, len,(jbyte *)igword);
		igword[len] = 0; //NULL-terminate
	} 
	else {
		env->DeleteLocalRef(exc);
	}
	env->DeleteLocalRef(bytes);
	//printf("It is %s \n",(unsigned char*)igword);
	return igword;
}

/************************************************************************************************************
	the following are the functions needed by the JNI native methods in the above
*************************************************************************************************************/


//AddToPersonalList() add the input word to the current personal list so that this word won't be considered as
//an incorrect word any more in the future
//input:
//	speller:		the spell checker engine
//	iword:			the word want to added (should be a word ended with '\0')
//return:
//	1:succeed		-1:something wrong happened
//created by H.Ma at 11.24.2003
int AddToPersonalList(AspellSpeller* speller,unsigned char* iword)
{
	aspell_speller_add_to_personal(speller,(char*)iword,-1);
	if(CheckError(speller)){
		return -1;
	}
	return 1;
}
//CheckCombinedWord() try to combine the word together to see if they cab be found from the dictionary. The way
//to combine these words is simple as long as it satisfies the following criteria:
//	(1)The center word is always included
//	(2)The order of the words are kept the same
//	(3)If one word is neigher the first nor the last one, then every symbols in this word is taken into account
//input:
//	speller:		the spell checker
//	wgroup:			the group of words (order is preserved)
//	wno:				the number of words in this group
//	center:			the index of the center word in this group of words
//	comword:		the returned words after combination
//	comwordno:	the number of the returned words after combination
//return:
//	positive:the number of returned words			-1:something wrong 
//	0:can not find the perfect combination
//created by H.Ma at 11.25.2003
int CheckCombinedWord(AspellSpeller* speller,CString* wgroup,int wno,int center,CString* &comword,int &comwordno)
{
	int i,j,id,k,m,pword_no;
	CString* nword=NULL;
	CString sword[3];
	CString* pword=NULL;
	CString* suggestion=NULL;
	bool perfect_combination;
	CString cword[20];

	nword=new CString[wno];
	if(nword==NULL){
		printf("Out of memory.\n");
		return -1;
	}
	pword=new CString[wno];
	if(pword==NULL){
		printf("Out of memory.\n");
		return -1;
	}
	perfect_combination=false;
	id=0;
	for(i=0;i<=center;i++){
		for(j=center;j<wno;j++){ //the word from i to j will be combined together
			id=0;
			for(k=0;k<i;k++)
				nword[id++]=wgroup[k];
			nword[id].Empty();
			for(k=i;k<=j;k++)
				nword[id]=nword[id]+wgroup[k];
			id++;
			for(k=j+1;k<wno;k++)
				nword[id++]=wgroup[k];
			//created a group of words by combination and put them in nword
			//delete the "-" or "_" or "~" from the word 
			for(k=0;k<id;k++)
				RemoveDashInWord(nword[k]);
		
			comwordno=0;
			pword_no=0;
			for(k=0;k<id;k++){
				ExtractPureWord((unsigned char*)LPCTSTR(nword[k]),sword);
				for(m=0;m<3;m++){
					if(!sword[m].IsEmpty())
						cword[comwordno++]=sword[m];
				}
				if(!sword[1].IsEmpty()){
					pword[pword_no++]=sword[1];
				}
			}
			//check if the pure words can be found from the dictionary
			for(k=0;k<pword_no;k++){
				m=CheckSingleWord(speller,(unsigned char*)LPCTSTR(pword[k]),suggestion);
				if(m>=0){ //incorrect word with or without suggestions
					delete [] suggestion;
					suggestion=NULL;
					break;
				}
			}
			if(k>=pword_no){
				perfect_combination=true;
				break;
			}
		}
		if(perfect_combination)
			break;
	}
	if(pword!=NULL){
		delete [] pword;
		pword=NULL;
	}
	if(nword!=NULL){
		delete [] nword;
		nword=NULL;
	}
	if(perfect_combination){
		comword=new CString[comwordno];
		if(comword==NULL){printf("Out of memory.\n"); return -1;}
		for(i=0;i<comwordno;i++)
			comword[i]=cword[i];
		return comwordno;
	}
	else{
		return 0;
	}
}
//CheckConfigError() check if the configuration has something wrong
//input:
//	config:	the AspellConfig configuration
//return:
//	0:no error 1:with error
//created by H.Ma at 11.24.2003
int CheckConfigError(AspellConfig* config)
{
	if(aspell_config_error(config)!=0){                         
		printf("Error: %s\n", aspell_config_error_message(config));  
		return 1;
	}
	else
		return 0;
}
//CheckDocumentNoCom() check the text document one by one word without combination. i.e. each word will be
//considered a correctly segmented word, even it is incorrect, don't try to combine it with other words
//input:
//	speller:	the spell checker
//	file:			the input text file
//return:
//	1:succeed	-1:failed
//created by H.Ma at 11.24.2003
int CheckDocumentNoCom(AspellSpeller* speller,char* file)
{
	FILE *fp;
	unsigned char wptr[100],pword[100];
	CString wstr;
	CString *corWord=NULL;
	int i,j,ctype,wlen,plen,sid,eid;
	
	fp=fopen(file,"rt");
	if(fp==NULL){
		printf("Can not open file %s to read word.\n",file);
		return -1;
	}
	while(fscanf(fp,"%s",wptr)!=EOF){
		//check the first and last character of this word, if a punctuation or symbol, extract them
		//from the word
		wstr.Format("%s",wptr);
		wlen=wstr.GetLength();
		plen=0;
		sid=-1;
		eid=-1;
		for(i=0;i<wlen;i++){
			ctype=LatinCharType((WCHAR)wptr[i]);
			if(ctype==1 || ctype==2){
				if(sid==-1){
					sid=i;
					eid=i;
					pword[plen++]=wptr[i];
				}
				else{
					eid=i;
					pword[plen++]=wptr[i];
				}
			}
			else{
				if(sid!=-1){
					for(j=i;j<wlen;j++){
						ctype=LatinCharType((WCHAR)wptr[j]);
						if(ctype==1 || ctype==2)
							break;
					}
					if(j<wlen){
						eid=i;
						pword[plen++]=wptr[i];
					}
					else break;
				}
			}
		}
		pword[plen]='\0';
		if(plen>0){
			i=CheckSingleWord(speller,pword,corWord);
			if(i>1){
				printf("Suggestions for word %s are:\n",pword);
				for(j=0;j<i;j++){
					printf("%s\n",corWord[j]);
				}
				delete [] corWord;
				corWord=NULL;
			}
		}
	}
	fclose(fp);
	return 1;
}
//CheckDocumentWithCom() check the text document one by one word. Once an incorrect word is identified,
//besides find the correct replacement for this single word, we also try to check if this word can be 
//combined with words in front of it or following it to provide a correct word
//input:
//	speller:	the spell checker
//	file:			the input text document file
//	range:		the combination range 
//return:
//	1:succeed		-1:failed
//created by H.Ma at 11.24.2003
int CheckDocumentWithCom(AspellSpeller* speller,char* file,int range)
{
	FILE *fp,*ft;
	unsigned char wptr[100];
	char rfile[300];
	CString wstr,sword[3];
	CString *corWord=NULL;
	CString *sug=NULL;
	int split_no,pop_no,twno,i,j,k,m,sug_no,center_id,corWordNo,qsize;
	CString *rword=NULL;
	CString *gword=NULL;
	CString *fword=NULL;
	SDQ smyq;
	IDQ imyq;
	SDQ::iterator spq;
	IDQ::iterator ipq;

	if(range<=0)
		CheckDocumentNoCom(speller,file);

	sprintf(rfile,"%s.check",file);
	
	gword=new CString[2*range+1];
	if(gword==NULL){printf("Out of memory.\n"); return -1;}
	
	//get the total number of words
	fp=fopen(file,"rt");
	if(fp==NULL){
		printf("Can not open file %s to read word.\n",file);
		return -1;
	}
	
	twno=0;
	while(fscanf(fp,"%s",wptr)!=EOF) twno++;
	rewind(fp);

	rword=new CString[twno];
	if(rword==NULL){printf("Out of memory.\n"); return -1;}
	for(i=0;i<twno;i++){
		fscanf(fp,"%s",wptr);
		rword[i].Format("%s",wptr);
	}
	fclose(fp);

	ft=fopen(rfile,"wt");
	if(ft==NULL){
		printf("Can not open file %s to write.\n",rfile);
		return -1;
	}

	for(k=0;k<twno;k++){
		split_no=ExtractPureWord((unsigned char*)LPCTSTR(rword[k]),sword);
		if(!sword[1].IsEmpty()){
			sug_no=CheckSingleWord(speller,(unsigned char*)LPCTSTR(sword[1]),sug);
			if(sug_no==0 || sug_no==-1){//The word is correct or incorrect but no suggestions can be found
				qsize=imyq.size();
				if(qsize<(2*range+1)){//no safe word
					imyq.push_back(split_no);
					for(i=0;i<3;i++){
						if(!sword[i].IsEmpty())
							smyq.push_back(sword[i]);
					}
				}
				else{//the first word is safe
					ipq=imyq.begin();
					pop_no=*ipq;
					imyq.pop_front();
					for(i=0;i<pop_no;i++){
						spq=smyq.begin();
						wstr=*spq;
						fprintf(ft,"%s ",wstr);
						smyq.pop_front();
					}
					fprintf(ft,"\n");
					//push the current word into the queue
					imyq.push_back(split_no);
					for(i=0;i<3;i++){
						if(!sword[i].IsEmpty())
							smyq.push_back(sword[i]);
					}
				}	
			}
			else{//incorrect word with suggestions
				int id=0;
				for(i=-range;i<=range;i++){
					if((k+i)>=0 && (k+i)<twno){
						gword[id]=rword[k+i];
						if(i==0){center_id=id;}
						id++;
					}
				}
				m=CheckCombinedWord(speller,gword,id,center_id,corWord,corWordNo);
				if(m>0){//found one perfect combination,skip the next neighbors (in range)
					k+=range;
					//first remove the safe string
					qsize=imyq.size();
					if(qsize>range){
						for(i=0;i<(qsize-range);i++){
							ipq=imyq.begin();
							pop_no=*ipq;
							imyq.pop_front();
							for(j=0;j<pop_no;j++){
								spq=smyq.begin();
								wstr=*spq;
								fprintf(ft,"%s ",wstr);
								smyq.pop_front();
							}
						}
					}
					//clear the deque
					imyq.clear();
					smyq.clear();
					//ouput the perfect combination
					for(i=0;i<corWordNo;i++)
						fprintf(ft,"%s ",corWord[i]);
					fprintf(ft,"\n");
				}
				else{//no perfect combination, output the first suggestion to the deque
					if(imyq.size()<(2*range+1)){//no safe word
						imyq.push_back(split_no);
						for(i=0;i<3;i++){
							if(!sword[i].IsEmpty()){
								if(i==1){
									if(sug_no>0)
										//smyq.push_back(sug[0]);
										smyq.push_back(sword[i]);
									else
										smyq.push_back(sword[i]);
								}
								else
									smyq.push_back(sword[i]);
							}
						}
					}
					else{//the first word is safe
						ipq=imyq.begin();
						pop_no=*ipq;
						imyq.pop_front();
						for(i=0;i<pop_no;i++){
							spq=smyq.begin();
							wstr=*spq;
							fprintf(ft,"%s ",wstr);
							smyq.pop_front();
						}
						fprintf(ft,"\n");
						//push the current word into the queue
						imyq.push_back(split_no);
						for(i=0;i<3;i++){
							if(!sword[i].IsEmpty()){
								if(i==1){
									if(sug_no>0)
										//smyq.push_back(sug[0]);
										smyq.push_back(sword[i]);
									else
										smyq.push_back(sword[i]);
								}
								else
									smyq.push_back(sword[i]);
							}
						}
					}	
					delete [] corWord;
					corWord=NULL;
				}
				delete [] sug;
				sug=NULL;
			}
		}
		else{//the whole word does not contain even one regular character, don't check
			qsize=imyq.size();
			if(qsize<(2*range+1)){//no safe word
				imyq.push_back(split_no);
				for(i=0;i<3;i++){
					if(!sword[i].IsEmpty())
						smyq.push_back(sword[i]);
				}
			}
			else{//the first word is safe
				ipq=imyq.begin();
				pop_no=*ipq;
				imyq.pop_front();
				for(i=0;i<pop_no;i++){
					spq=smyq.begin();
					wstr=*spq;
					fprintf(ft,"%s ",wstr);
					smyq.pop_front();
				}
				fprintf(ft,"\n");
				//push the current word into the queue
				imyq.push_back(split_no);
				for(i=0;i<3;i++){
					if(!sword[i].IsEmpty())
						smyq.push_back(sword[i]);
				}
			}	
		}
	}
	if(!imyq.empty()){
		qsize=imyq.size();
		for(i=0;i<qsize;i++){
			ipq=imyq.begin();
			pop_no=*ipq;
			imyq.pop_front();
			for(j=0;j<pop_no;j++){
				spq=smyq.begin();
				wstr=*spq;
				fprintf(ft,"%s ",wstr);
				smyq.pop_front();
			}
		}
	}
	fclose(ft);
	return 1;
}
//CheckError() check if the speller has something wrong (usually after performing some operations)
//input:
//	speller:	the AspellSpeller speller
//return:
//	0:no error	1:with error
//created by H.Ma at 11.24.2003
int CheckError(AspellSpeller* speller)
{
	if(aspell_speller_error(speller)!=0){
		printf("Error: %s\n", aspell_speller_error_message(speller)); 
    return 1;                                                        
  }
	else
		return 0;
}
//check_word() check if the spelling of the input word is correct, if it is incorrect, then give some
//suggestions to replace this word based on the dictionary
//input:
//	speller:	the spell check engine
//	iword:		the input word (should be a string ended with '\0'
//	suggestion: the return suggestions if incorrect input word
//return:
//	posititve the number of suggestions
//	-1: correct word
//	0: something wrong or can not find a replacement for an incorrect word
//created by H.Ma at 11.24.2003
int CheckSingleWord(AspellSpeller* speller,unsigned char* iword,CString* &suggestion)
{
	int correct,sno,i;
	const AspellWordList *wl=NULL;
	AspellStringEnumeration *els;
	const char *sug;
	CString AllSuggestions[500];
	
	//printf("Input word is %s\n",iword);
	correct=aspell_speller_check(speller,(char*)iword,-1);
	//printf("Correct value is %d\n",correct);
	if(correct==1) //correct word
		return -1;
	wl=aspell_speller_suggest(speller,(char*)iword,-1);
	els=aspell_word_list_elements(wl);
	sno=0;
	while((sug=aspell_string_enumeration_next(els))!=0){
		AllSuggestions[sno].Format("%s",sug);
		sno++;
	}
	if(sno>=1){
		suggestion=new CString[sno];
		for(i=0;i<sno;i++){
			suggestion[i]=AllSuggestions[i];
		}
		return sno;
	}
	else{
		//printf("Something must be wrong, an incorrect word does not have any suggestions.\n");
		return 0;
	}
}
//ExtractPureWord() try to separate the symbols and puctuations for a word. Only the non-latin letters 
//at the beginning and end of the word can be separated. The order of the result is prefix_symbol,center_word,
//suffix_symbol. If the whole word does not contain even one regular characer, then except the first pureword,
//the other two pureword are empty.
//input:
//	iword:		the input word
//	pureword:	the returned separated word
//return:
//	the separated component number (can only be 1, 2, 3)
//		1:	if pureword[0] is not empty, then it is a symbol word, if pureword[1] is not empty, then it is a 
//				regualar word
//		2:	if pureword[0] is not empty, then the word is pureword[0] + pureword[1], otherwise the word is
//				pureword[1] + pureword[2]
//		3:	the word is pureword[0] + pureword[1] + pureword[2]
//created by H.Ma at 11.24.2003				
int ExtractPureWord(unsigned char* iword,CString pureword[3])
{
	int plen,sid,eid,ctype,wlen,i,j;
	CString wstr;
	unsigned char tword[100];
	int returnno;

	for(i=0;i<3;i++)
		pureword[i].Empty();

	wstr.Format("%s",iword);
	wlen=wstr.GetLength();
	
	plen=0;
	sid=-1;
	eid=-1;
	for(i=0;i<wlen;i++){
		ctype=LatinCharType((WCHAR)iword[i]);
		if(ctype==1 || ctype==2){
			if(sid==-1){
				sid=i;
				eid=i;
				tword[plen++]=iword[i];
			}
			else{
				eid=i;
				tword[plen++]=iword[i];
			}
		}
		else{
			if(sid!=-1){
				for(j=i;j<wlen;j++){
					ctype=LatinCharType((WCHAR)iword[j]);
					if(ctype==1 || ctype==2)
						break;
				}
				if(j<wlen){
					eid=i;
					tword[plen++]=iword[i];
				}
				else break;
			}
		}
	}
	tword[plen]='\0';

	if(plen>0){
		returnno=1;
		pureword[1].Format("%s",tword);
		if(sid>0){
			for(i=0;i<sid;i++)
				tword[i]=iword[i];
			tword[i]='\0';
			pureword[0].Format("%s",tword);
			returnno++;
		}
		if(eid<(wlen-1)){
			int id=0;
			for(i=eid+1;i<wlen;i++)
				tword[id++]=iword[i];
			tword[id]='\0';
			pureword[2].Format("%s",tword);
			returnno++;
		}
	}
	else{
		pureword[0]=wstr;
		returnno=1;
	}
	return returnno;
}
//IgonreWord() ignore the input word for the rest of this session, i.e. for the rest of the document, this word won't 
//be considered an incorrect word any more (while we don't want to add it to the personal word list)
//input:
//	speller:	the spell checker
//	iword:		the input word we want to ignore (should be a string ended with '\0')
//return:
//	1:succeed	-1:failed
//created by H.Ma at 11.24.2003	
int IgnoreWord(AspellSpeller* speller,unsigned char* iword)
{
	aspell_speller_add_to_session(speller,(char*)iword,-1);
	if(CheckError(speller))
		return -1;
	else
		return 1;
}
//LatinCharType() determines the type of an input Latin character based on the input unicode
//input:
//	ucode:	the unicode of the input character
//return:
//	the type of the character
//		0:	non-latin character
//		1:	Uppercase of Latin letters
//		2:	Lowercase of Latin letters
//		3:	Arabic digits
//		4:	Punctuation 
//		5:	Symbols
//		6:	Others
//		-1:	something wrong
int LatinCharType(WCHAR ucode)
{
	WCHAR Punctuation[31]={0x0021,0x0022,0x0027,0x0028,0x0029,0x002C,0x002E,0x003A,0x003B,0x003F,0x005B,0x005D,\
													0x005F,0x0060,0x007B,0x007D,0x00A1,0x00A8,0x00AB,0x00AC,0x00AF,0x00B0,0x00B4,0x00B7,\
													0x00B8,0x00BB,0x00BF,0x00C0,0x00C1,0x00C2,0x00C3};
	WCHAR Symbol[28]={0x0023,0x0024,0x0025,0x0026,0x002A,0x002B,0x002F,0x003C,0x003D,0x003E,0x0040,0x005C,0x005E,\
										0x00A2,0x00A3,0x00A4,0x00A5,0x00A6,0x00A7,0x00A9,0x00AE,0x00B1,0x00B5,0x00B6,0x00D7,0x00F7,\
										0x002D,0x007E};
	WCHAR Lower[81]={0x0180,0x0183,0x0185,0x0188,0x018C,0x018D,0x0192,0x0195,0x0199,0x019A,0x019B,0x019E,0x01A1,\
									0x01A3,0x01A5,0x01A8,0x01AB,0x01AD,0x01B0,0x01B4,0x01B6,0x01B9,0x01BA,0x01BD,0x01C6,0x01C9,\
									0x01CC,0x01CE,0x01D0,0x01D2,0x01D4,0x01D6,0x01D8,0x01DA,0x01DC,0x01DD,0x01DF,0x01E1,0x01E3,\
									0x01E5,0x01E7,0x01E9,0x01EB,0x01ED,0x01EF,0x01F0,0x01F3,0x01F5,0x01F9,0x01FB,0x01FD,0x01FF,\
									0x0201,0x0203,0x0205,0x0207,0x0209,0x020B,0x020D,0x020F,0x0211,0x0213,0x0215,0x0217,0x0219,\
									0x021B,0x021D,0x021F,0x0221,0x0223,0x0225,0x0227,0x0229,0x022B,0x022D,0x022F,0x0231,0x0233,\
									0x0235,0x0236,0x017F};
	WCHAR Upper[97]={0x0181,0x0182,0x0184,0x0186,0x0187,0x0189,0x018A,0x018B,0x018E,0x018F,0x0190,0x0191,0x0193,\
									0x0194,0x0196,0x0197,0x0198,0x019C,0x019D,0x019F,0x01A0,0x01A2,0x01A4,0x01A6,0x01A7,0x01AA,\
									0x01AC,0x01AE,0x01AF,0x01B1,0x01B2,0x01B3,0x01B5,0x01B7,0x01B8,0x01BB,0x01BC,0x01BE,0x01BF,\
									0x01C4,0x01C5,0x01C7,0x01C8,0x01CA,0x01CB,0x01CD,0x01CF,0x01D1,0x01D3,0x01D5,0x01D7,0x01D9,\
									0x01DB,0x01DE,0x01E0,0x01E2,0x01E4,0x01E6,0x01E8,0x01EA,0x01EC,0x01EE,0x01F1,0x01F2,0x01F4,\
									0x01F6,0x01F7,0x01F8,0x01FA,0x01FC,0x01FE,0x0200,0x0202,0x0204,0x0206,0x0208,0x020A,0x020C,\
									0x020E,0x0210,0x0212,0x0214,0x0216,0x0218,0x021A,0x021C,0x021E,0x0220,0x0222,0x0224,0x0226,\
									0x0228,0x022A,0x022C,0x022E,0x0230,0x0232};

	int i;
	WCHAR j;

	//first determine if a Latin character (0x0000~0x0236)
	if(ucode<0x0000 || ucode>0x0236) //non-latin character
		return 0;
	if(ucode>=0x0030 && ucode<=0x0039) //arabic digits
		return 3;
	for(i=0;i<31;i++){  //punctuations
		if(ucode==Punctuation[i])
			return 4;
	}
	for(i=0;i<28;i++){  //symbols
		if(ucode==Symbol[i])
			return 5;
	}
	for(j=0x0041;j<=0x005A;j++){
		if(ucode==j)
			return 1;
	}
	for(j=0x00C0;j<=0x00D6;j++){
		if(ucode==j)
			return 1;
	}
	for(j=0x00D8;j<=0x00DF;j++){
		if(ucode==j)
			return 1;
	}
	for(j=0x0100;j<=0x0176;j=j+2){
		if(ucode==j)
			return 1;
	}
	if(ucode==0x0178 || ucode==0x0179 || ucode==0x017B || ucode==0x017D)
		return 1;
	for(i=0;i<97;i++){
		if(ucode==Upper[i])
			return 1;
	}
	//determine if lowercase
	for(j=0x0061;j<=0x007A;j++){
		if(ucode==j)
			return 2;
	}
	for(j=0x00E0;j<=0x00F6;j++){
		if(ucode==j)
			return 2;
	}
	for(j=0x00F8;j<=0x00FF;j++){
		if(ucode==j)
			return 2;
	}
	for(j=0x0101;j<=0x0177;j=j+2){
		if(ucode==j)
			return 2;
	}
	if(ucode==0x017A || ucode==0x017C || ucode==0x017E || ucode==0x017F)
		return 2;
	for(i=0;i<81;i++){
		if(ucode==Lower[i])
			return 2;
	}
	return 6;
}
int RemoveDashInWord(CString &iword)
{
	iword.Remove('-');
	iword.Remove('_');
	iword.Remove('~');	
	return(iword.GetLength());
}
//SelectDictionary() select the dictionary want to use for the checking
//input:
//	config:	the configuration engine of the spell checker
//	lang:		the language
//	jargon:	the appendix option of this language
//return:
//	1:succeed	-1:failed
//created by H.Ma at 11.24.2003
int SelectDictionary(AspellConfig* config,char* lang,char* region)
{
	aspell_config_replace(config, "lang", lang);
	if(region!=NULL)
		aspell_config_replace(config, "region", region);
	return 1;
}
//SetDictDirectory() set the directory of the data and dictionary
//input:
//	config:		the configuration engine of the spell checker engine
//	dataDir:	the data directory
//	dictDir:	the dict directory
//return:
//	1:succeed		-1:failed
//created by H.Ma at 11.24.2003
int SetDictDirectory(AspellConfig* config,char* dataDir,char* dictDir)
{
	aspell_config_replace(config,"dict-dir",dictDir);
	aspell_config_replace(config,"data-dir",dataDir);
	return 1;
}

