package other;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
/**
 * Class for generating a file named "Readme" in the given directory and possibly its
 * subdirectories. The Readme file will contain the names of the files in that directory. This can
 * be useful for creating documentation.
 * @author Tandeep Sidhu
 */
public class ReadmeFileGenerator {

	/**
	 * 
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ReadmeFileGenerator.generate(new File("C:\\BRIDGE\\Tides"), true);
	}
	/**
	 * Generates the Readme file in the specified directory
	 * @param dir The File object for the dir
	 * @param browseSubDirs If set to true, will generate Readme files for all subdirectories also.
	 */
	static public void generate(File dir, boolean browseSubDirs) {
		File readmeFile = new File(dir, "Readme.txt");
		
		if(dir.isDirectory() == false) return;
		if(readmeFile.exists() == false) return;
		
		File[] files = dir.listFiles();
		
		if(readmeFile.length() ==  0) {
			
		
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(readmeFile));
			
			bw.write("Readme File. Contains info about files in this directory");
			bw.newLine();
			bw.newLine();
			bw.newLine();
			
			
			for (int i = 0; i < files.length; i++) {
				if(files[i].getName().equals("Readme.txt") == false && files[i].getName().indexOf('~') == -1) {
					bw.write(files[i].getName());
					
					if(files[i].isDirectory())
						bw.write("(D):");
					else
						bw.write("(F):");
					bw.newLine();
					bw.newLine();
				}
			}
			bw.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		}
		if(browseSubDirs)
			for (int j = 0; j < files.length; j++) {
				generate(files[j], browseSubDirs);
			}
	}
}
