package other;


/**
 * TimeUtil: a few static functions that convert from seconds to string, and from string to seconds
 * @author Tandeep Sidhu
 */
public class TimeUtil {
    
    /**
     * String in format of hh:mm:ss. Returns -1 if seconds is negative.
     * @param seconds
     * 
     */
    public static String convertSecsToStr (int seconds) {
		if(seconds < 0) return "-1";
    	
    	String time;
		
		int secs = seconds%60;
		int minutes = seconds/60;
		int mins = minutes%60;
		int hours = minutes / 60;
		
		if (hours < 10) {
			time = "0"+hours+":";
		}
		else {
			time = hours+":";
		}
		
		if (mins < 10) {
			time = time+"0"+mins+":";
		}
		else {
			time = time + "" + mins+":";
		}
		
		if (secs < 10) {
			time = time+"0"+secs;
		}
		else {
			time = time + "" + secs;
		}
		
		return time;
	}
	
    /**
     * @param timeStr in format (hh:mm:ss)
     * @return number of seconds
     * @throws NumberFormatException if error in parsing the string 
     */
	public static int convertStrToSecs (String timeStr){
		int secs = 0;
		
		timeStr = timeStr.trim();
		
		secs += Integer.parseInt(timeStr.substring(6,8));
		secs += Integer.parseInt(timeStr.substring(3,5))*60;
		secs += Integer.parseInt(timeStr.substring(0,2))*60*60; 
		
		return secs;
	}
	/**
	 * Converts seconds to mm:ss format and returns the result. Return "-1" if seconds parameter is negative
	 * @param totalSeconds total number of seconds
	 */
    public static String secondsToMinSecStr(int totalSeconds){
    	if(totalSeconds < 0) return "-1";
    	
        int iMinutes = totalSeconds / 60;
        int iSeconds = totalSeconds % 60;
        return iMinutes + ":" + iSeconds;
    }

}
