package other;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
/**
 * Given list of files, creats a zip file out of these files(with user defined output file name)
 */
public class ZipFileCreator {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
//		createZipFile();
	}
	/**
	 * Given list of files, creates a zip file
	 * @param filenames List of filenames
	 * @param outFilename Name of the output file
	 */
	public static void createZipFile(ArrayList<File> filenames, File outFilename) {
		
		 // These are the files to include in the ZIP file
//	    String[] filenames = new String[]{"C:\\BRIDGE\\Tides\\doc\\Readme.txt"};
	    
	    // Create a buffer for reading the files
	    byte[] buf = new byte[1024];
	    
	    try {
	        // Create the ZIP file
//	        String outFilename = "C:\\BRIDGE\\Tides\\doc\\outfile.zip";
	        ZipOutputStream out = new ZipOutputStream(new FileOutputStream(outFilename));
	    
	        // Compress the files
	        for (int i=0; i<filenames.size(); i++) {
	            FileInputStream in = new FileInputStream(filenames.get(i));
	    
	            // Add ZIP entry to output stream.
	            out.putNextEntry(new ZipEntry(filenames.get(i).toString()));
	    
	            // Transfer bytes from the file to the ZIP file
	            int len;
	            while ((len = in.read(buf)) > 0) {
	                out.write(buf, 0, len);
	            }
	    
	            // Complete the entry
	            out.closeEntry();
	            in.close();
	        }
	    
	        // Complete the ZIP file
	        out.close();
	    } catch (IOException e) {
	    }
	}
}
