package swing.components;

import java.awt.FlowLayout;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Simple gui class to display a label and a user defined component in a jpanel with user defined
 * orientation
 * @author Tandeep Sidhu
 */
public class ComponentWithLabel extends JPanel{
	JLabel txt;
	private JComponent comp;
	public final static int X_AXIS = 0;
	public final static int Y_AXIS = 1;
	
	/**
	 * Builds the jpanel and the label
	 * @param labelTxt text for the label
	 * @param comp user defined component
	 * @param orient orientation. X_AXIS for the 2 components in horizontal direction, Y_AXIS for vertical direction
	 */
	public ComponentWithLabel(String labelTxt, JComponent comp, int orient){
		txt = new JLabel(labelTxt);
		this.comp = comp;
		if(orient == Y_AXIS)
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		else
			setLayout(new FlowLayout(FlowLayout.LEADING));
		
		add(txt);
		add(comp);
		txt.setAlignmentX(0);
		comp.setAlignmentX(0);
		setAlignmentX(0);
	}
	/**
	 * Enable the component and the label
	 */
	public void setEnabled(boolean enabled) {
		comp.setEnabled(enabled);
		txt.setEnabled(enabled);
	}
}

