package text;


/*
 * Created on Mar 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author priyaw
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/*
 * Created on Jul 16, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * Class used to replacing accent characters found in a string. So a string like "Maest" will be converted to Maesta.
 * The mapping of accent characters to normal characters is read from a file. Though, this file cannot be changed,
 * this class provides methods for updating these mappings.
 * @author Tandeep Sidhu
 */
public class CharacterReplace {
    static Hashtable characterTable = new Hashtable();
    static boolean configurationRead = false;
	static String charReplaceFileName = "Character.txt";

    /**
     * Loads the mappings from a file
     */
    private static void loadMap()
    {
        try{
			BufferedReader in = new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream("text/"+charReplaceFileName)));
		
			String line, all ="";
			while((line = in.readLine()) != null){
				StringTokenizer st = new StringTokenizer(line);
				String oldChar="", newChar;
				if (st.hasMoreTokens()){
					oldChar = st.nextToken();
				}
				if (st.hasMoreTokens()){
					newChar = st.nextToken();
				}
				else {
					newChar = oldChar;
				}
				if (!oldChar.trim().equals(""))
					characterTable.put(oldChar, newChar);
			}
			in.close();
	    }
		catch (IOException ioe){
//            ioe.printStackTrace();
		    System.err.println(ioe.getMessage());
        }
		configurationRead = true;
    }
    
	private static String replaceCharacters(String oldString){
		StringBuffer newString = new StringBuffer(oldString);
		Iterator keys = characterTable.keySet().iterator();
		while (keys.hasNext()){
			String oldChar = (String)keys.next();
            String replacingChar = (String)characterTable.get(oldChar);
			int pos = newString.toString().indexOf(oldChar); 
			while (pos != -1){
				newString.replace(pos, pos+oldChar.length(), replacingChar);
				pos = newString.toString().indexOf(oldChar, pos + 1);
			}
		}
		return newString.toString();
	}
	/**
	 * Replaces the accent characters in the string with their mappings and returns the result
	 */
	public static String removeAccent (String accented) {

        //load config if config not yet loaded or new dictionary is loaded
        if(configurationRead == false )
            loadMap();

        return replaceCharacters(accented);
	}
	/**
	 * Returns the mappings as a 2d array
	 */
    public static String[][] getMapAs2DVector()
    {
        if(configurationRead == false)
            loadMap();

        if(characterTable.size() == 0) return null;
        
       Enumeration enumeration = characterTable.keys();
       String [][] map = new String[characterTable.size()][];
       
       for(int i = 0; enumeration.hasMoreElements(); i++) {
           String key = (String) enumeration.nextElement();
           
           String value = (String) characterTable.get(key);
           map[i] = new String[2];
           
           map[i][0] = key;
           map[i][1] = value;
       }
       
       return map;
    }
//    /**
//     * 
//     * @param vector
//     * @param currentDicDir
//     * @param filename
//     */
//    public static void saveMap(Vector<String> vector, String currentDicDir, String filename)
//    {
//        File fileToWrite = new File(currentDicDir, filename);
//        
//        try
//        {
//            BufferedWriter bf = new BufferedWriter(new FileWriter(fileToWrite));
//            
//            for (Iterator iter = vector.iterator(); iter.hasNext();)
//            {
//                Vector element = (Vector) iter.next();
//                
//                String key = (String) element.get(0);
//                String value = (String) element.get(1);
//                
//                bf.write(key + " " + value);
//                bf.newLine();
//            }
//            
//            bf.close();
//        }
//        catch (IOException e)
//        {
//            e.printStackTrace();
//        }
//        
//        
//        loadMap();
//    }
    
    public static void main(String[] args) {
		System.out.println(CharacterReplace.removeAccent("Maest"));
	}
    
}

