package text;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;

public class StringUtil {
	/**
	 * Concatenates elements of the list separated by the given delimiter and returns the result
	 */
	public static String getListAsString(List list, String delimiter) {
		if(list ==  null) return "";
		StringBuffer sb = new StringBuffer("");
				
		for (Iterator iter = list.iterator(); iter.hasNext();) {
			Object element = (Object) iter.next();
			
			sb.append(element);
			
			if(iter.hasNext())
				sb.append(delimiter);
		}
		return sb.toString();
	}
	/**
	 * Checks wither the string is empty. String "" and null is empty string. Anything else is not empty
	 * @return Returns true if string is empty, false otherwise
	 */
	public static boolean isEmpty(String text) {
		return text == null || text.trim().equals("");
	}
	
	/**
	 * Removes any spaces in the string.
	 */
	public static String removeSpaces(String text) {
		StringBuffer str = new StringBuffer("");
		
		for(int i = 0; i < text.length(); i++)
			if(text.charAt(i)!= ' ' && text.charAt(i)!= '\n' && text.charAt(i)!= '\r')
				str.append(text.charAt(i));
		
		return str.toString();
	}
	/**
	* Removes extension and the dot from a string
	*/
	public static String removeExtension(String str)
	{
		int indexOfDot = str.lastIndexOf(".");
		if(indexOfDot == -1)
			return str;
			
		return str.substring(0, indexOfDot );
	}

	/**
	 * Returns true if the string contains spaces false otherwise
	 */
	public static boolean containsSpaces(String str) {
		String[] strings = str.split(" ");
		
		if(strings.length > 1) return true;
		return false;
	}	
	/**
	 * Reads a file specified by the parameter into a string and returns the result
	 * Each line in the file is appended by '\n' in the result string
	 * @param file
	 * @return
	 */
	public static String readFileIntoString(File file) {
		BufferedReader br;
		StringBuffer tmp = new StringBuffer();

		try {
			br = new BufferedReader(new FileReader(file));

			String line = br.readLine();

			while(line != null) {
				tmp.append(line);
				tmp.append("\n");
				line = br.readLine();
			}

			br.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return tmp.toString();


	}
	/**
	 * If a string contains more than one word (separated by space), returns the last word
	 * @param str
	 * @return
	 */
	public static String getLastWord(String str) {
		String[] strings = str.split("\\s+");
		
		return strings[strings.length-1];
	}
}
